/*
 * Created on Apr 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.imaginot.swing.*;
import com.imaginot.chess.engine.*;

/**
 * @author dkappe
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ChessVisualizationTrainer extends JFrame {

	public final static String VERSION = "Chess Trainer 1.2.0";

	public static OpeningDB book = null;

	public ChessVisualizationTrainer() {
		super(VERSION);
		setSize(500, 550);
		setResizable(false);

		initBook();

		JMenuBar mb = new JMenuBar();
		JMenu m = new JMenu("Info");
		m.add(new AbstractAction("About...") {
			public void actionPerformed(ActionEvent e) {
				popupinfo();
			}
		});
		mb.add(m);

		JTabbedPane jtp = new JTabbedPane();
		jtp.addTab("Help", new HelpPanel());
		jtp.addTab("Color", new SquareColorTest());
		jtp.addTab("Same Color", new SameColorTest());
		jtp.addTab("Diagonal 2", new SameDiagonalTest2());
		jtp.addTab("Diagonal 3", new SameDiagonalTest3());
		jtp.addTab("Knight", new KnightTest());
		jtp.addTab("Knight 2", new KnightTest2());
		jtp.addTab("Mate", new MateTest());
		jtp.addTab("Openings", new OpeningTest());
		jtp.addTab("Vince", new PlayTest());
		Container c = getContentPane();

		setJMenuBar(mb);
		c.add(jtp);

		addWindowListener(new BasicWindowMonitor());
	}

	public void initBook() {
		ClassLoader cl = this.getClass().getClassLoader();
		try {
			book =
				new OpeningDB(
					cl.getResource("com/imaginot/chess/engine/book.pgn").openStream());
		} catch (Exception e) {
			book = null;
		}
	}

	public void popupinfo() {
		JOptionPane.showMessageDialog(
			this,
			VERSION + " (see http://chesstraining.sourceforge.net)",
			"About",
			JOptionPane.INFORMATION_MESSAGE);
	}
	public static void main(String[] args) {
		// splash screen

		Splash spl = new Splash(VERSION, "com/imaginot/chess/splash.jpg");
		spl.showSplash();
		// main app
		ChessVisualizationTrainer cvt = new ChessVisualizationTrainer();
		spl.hideSplash();
		spl = null;
		cvt.setVisible(true);
	}
}
