/*
 * Created on Apr 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import java.util.List;


/**
 * @author dkappe
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SameDiagonalTest2 extends JPanel {
	private int totalQuestions = 0;
	private int totalRight = 0;

	private Square current1 = new Square();
	private Square current2 = null;
	
	private JLabel status = new JLabel("Good Luck!");
	private JLabel score = new JLabel("");
	private JLabel sqr = new JLabel("");

	class NoAction extends AbstractAction {
		public NoAction() {
			super("No");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(false);
		}

	}

	class YesAction extends AbstractAction {
		
		public YesAction() {
			super("Yes");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(true);
		}

	}
	
	private void checkResult(boolean isSame) {
		String relation = (current1.sameDiagonal(current2))? "on the same diagonal.":
			"NOT on the same diagonal.";
		if (isSame == current1.sameDiagonal(current2)) {
			totalRight++;
			status.setText("Correct, " + current1 + " and " +
				current2 +
				" are " + relation);
			status.setForeground(Color.BLACK);
		} else {
			status.setText("Wrong! " + current1 + " and " +
				current2 +
				" are " + relation);
			status.setForeground(Color.RED);
		}
		showScore();
		nextSquare();
	}
	
	private void showScore() {
		if (totalQuestions == 0) {
			score.setText("Score: N/A");
		} else {
			int percent = (100*totalRight/totalQuestions);
			score.setText("Score: " + percent + "% (" +
				totalRight + " of " + totalQuestions + ")");
		}
	}
	
	private void nextSquare() {
		current1 = current1.genInstance();
		List moves = current1.genDiagonal(1,1);
		moves.addAll(current1.genDiagonal(1,-1));
		int size;
		int choice;
			
		size = moves.size();
		
		current2 = (Square)moves.get(Square.rand(size));
		if (Math.random() > 0.2) { // get something off the diagonal much of the time
			current2 = current2.genCloseInstance();
			if (current2.sameSquare(current1)) {
				current2 = current1.genInstance();
			}
		}
		totalQuestions++;
		sqr.setText("Are " + current1.toString() +
			" and " + current2.toString() + " on the same diagonal?");
	}
	
	public SameDiagonalTest2() {
		super();
		setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		
		gbc.insets = new Insets(10,10,10,10);
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 3;
		
		add(status, gbc);
		
		gbc.gridy = 1;
		
		add(sqr,gbc);
		
		JToolBar jtp = new JToolBar();
		jtp.setFloatable(false);
		
		jtp.add(new YesAction());
		jtp.add(new NoAction());
		
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 3;
		
		add(jtp, gbc);
		
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 3;
		
		add(score, gbc);
		
		showScore();
		nextSquare();
		
	}
}
