/*
 * Created on May 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.learning;

import java.util.*;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DefaultLearningBox implements LearningBox {

	public static final int BOX_SIZE = 10;
	private static int[] sizes = {BOX_SIZE, 2 * BOX_SIZE, 4 * BOX_SIZE};
	private QuestionGenerator qg;
	private List box[];
	private int currentBox = 0;
	
	public DefaultLearningBox(QuestionGenerator qg) {
		this.qg = qg;
		box = new List[3];
		box[0] = new ArrayList();
		box[1] = new ArrayList();
		box[2] = new ArrayList();
	}
	
	/* (non-Javadoc)
	 * @see com.imaginot.learning.LearningBox#nextQuestion()
	 */
	public Object nextQuestion() throws NoMoreQuestionsException {
		if (box[currentBox].size() < 1) {
			currentBox = 0;
		}
		if (box[0].size() < 1) { // refill the first box
			refill();
			findFirstFull();
			if (box[currentBox].size() < 1) { // still empty, so complain
				throw new NoMoreQuestionsException("No more questions.");
			}
		}
		return box[currentBox].get(0);
	}

	private void findFirstFull() {
		currentBox = 0;
		if (box[0].size() > 0) {
			currentBox = 0;
		} else if (box[1].size() > 0) {
			currentBox = 1;
		} else if (box[2].size() > 0) {
			currentBox = 2;
		}
	}
	
	private void refill() {
		while (box[0].size() < sizes[0]) {
			try {
				Object o = qg.nextQuestion();
				//System.err.println("Addind item.");
				box[0].add(o);
			} catch (NoMoreQuestionsException e) {
				return;
			}
		}
	}
	/* (non-Javadoc)
	 * @see com.imaginot.learning.LearningBox#answer(boolean)
	 */
	public void answer(boolean correct) {
		// move the current question up a notch and go to the next box
		if (box[currentBox].size() < 1) {
			findFirstFull();
			return;
		}
		// handle the last box
		if (currentBox == 2) {
			if (correct) { // get rid of it
				box[currentBox].remove(0);
			} else { // get it and move it back to the first spot
				Object o = box[currentBox].get(0);
				box[currentBox].remove(0);
				box[0].add(o);
			}
			// now, if we have gone past the threshhold, go to the first box
			if ((sizes[currentBox] - box[currentBox].size()) >= BOX_SIZE) {
				// we've take enough, so go to first box
				
			}
		} else { // we are in an earlier box
			Object o = box[currentBox].get(0);
			box[currentBox].remove(0);
			if (correct) {
				// move it up
				box[currentBox+1].add(o);
				if (box[currentBox+1].size() >= sizes[currentBox+1]) {
					currentBox++;
				} else if ((sizes[currentBox] - box[currentBox].size()) >= BOX_SIZE) {
					// we have taken enough
					currentBox = 0;
				}
			} else {
				// move it to the first box
				box[0].add(o);
				if (box[0].size() >= sizes[0]) { // go home if we've filled it up
					currentBox = 0;
				}
			}
		}
		
		if ((currentBox == 0) && (box[0].size() < 3)) { // time to refill
			refill();
		}
	}

	public void dump() {
		System.err.println("Box = " + currentBox);
		System.err.println("size 0 = " + box[0].size());
		System.err.println("size 1 = " + box[1].size());
		System.err.println("size 2 = " + box[2].size());
	}
}
